-- PARMETROS : P_CDEMPRESA - CDIGO DA EMPRESA                       --
--              P_NRLANCCONT - NMERO DO LANAMENTO                   --
--              P_EXEC_ALT - STATUS ('E'- EXCLUSO, 'A' -  ALTERAO) --
-- 9011_CTBSTP_EXCLUI_LANCAMENTO.SQL                                  --

--DBMS_OUTPUT.PUT_LINE('');

CREATE OR REPLACE PROCEDURE EXCLUI_LANCAMENTO (
       P_CDEMPRESA IN    EMPRESA.CDEMPRESA%TYPE,
       P_NRLANCCONT IN   LANCCONT.NRLANCCONT%TYPE,
       P_EXEC_ALT CHAR )
IS
   V_IDCONTGERE  CHAR;
   V_IDCONTCOME  CHAR;
   V_NRSEQLANEX  VARCHAR2(10);
   V_NRSEQCCEX   VARCHAR2(10);
   V_NRSEQLANCOM VARCHAR2(10);

BEGIN

   SELECT MAX(IDCONTGERE), MAX(IDCONTCOME) INTO V_IDCONTGERE,V_IDCONTCOME
   FROM CONTOPECTBL
   WHERE(CDEMPRESA = P_CDEMPRESA);

   SELECT NVL(MAX(NRSEQLANEX), 0) INTO V_NRSEQLANEX
   FROM LANCONTEX
   WHERE NRLANCONTA = P_NRLANCCONT;

   SELECT NVL(MAX(NRSEQLANCOM), 0) INTO V_NRSEQLANCOM
   FROM LANCOMEEX
   WHERE NRLANCCOM = P_NRLANCCONT;

   SELECT NVL(MAX(NRSEQCCEX), 0) INTO V_NRSEQCCEX
   FROM LANCCEXC
   WHERE NRLANCONGE = P_NRLANCCONT;

   FOR LANCCONT_C IN (SELECT
                         VRLANCAMENT * (-1) AS VALOR,
                         CDCONTCTBL,
                         DTLANCCONT,
                         IDLANCCOME,
                         CDCONTCOME,
                         IDLANCSALDO,
                         IDSALDLANCO
                      FROM LANCCONT
                      WHERE (LANCCONT.CDEMPRESA = P_CDEMPRESA )  AND
                            (LANCCONT.NRLANCCONT = P_NRLANCCONT) ) LOOP

      IF LANCCONT_C.IDLANCSALDO = 'S' THEN

         V_NRSEQLANEX := V_NRSEQLANEX + 1;

         INSERT INTO LANCONTEX
            (NRSEQLANEX, NRLANCONTA, CDEMPRESA, CDCONTALAEX, CDCONTCOMEX,
             IDCONTCOMEX, DTLANCCONEX, VRLANCCONEX)
         VALUES
            (V_NRSEQLANEX, P_NRLANCCONT, P_CDEMPRESA, LANCCONT_C.CDCONTCTBL, LANCCONT_C.CDCONTCOME,
             LANCCONT_C.IDLANCCOME, LANCCONT_C.DTLANCCONT, LANCCONT_C.VALOR);
      END IF;

      IF LANCCONT_C.IDSALDLANCO = 'S' THEN
         IF (LANCCONT_C.CDCONTCOME IS NOT NULL) THEN
            V_NRSEQLANCOM := V_NRSEQLANCOM + 1;
            INSERT INTO LANCOMEEX
               (NRSEQLANCOM, NRLANCCOM, CDEMPRESA, CDCONTALACOM, CDCONTCOMCOM,
                IDCONTCOMCOM, DTLANCCONCOM, VRLANCCONCOM)
            VALUES(V_NRSEQLANCOM, P_NRLANCCONT, P_CDEMPRESA, LANCCONT_C.CDCONTCTBL, LANCCONT_C.CDCONTCOME,
                   LANCCONT_C.IDLANCCOME, LANCCONT_C.DTLANCCONT, LANCCONT_C.VALOR);
         END IF;
      END IF;

   END LOOP;

   FOR LANCCUSTO_C IN (SELECT
                          LANCCCUSTO.VRLANCCUST * (-1) AS VALOR,
                          LANCCCUSTO.CDFILIAL,
                          LANCCCUSTO.CDCENTCUST,
                          LANCCONT.DTLANCCONT,
                          LANCCONT.CDCONTCTBL,
                          LANCCONT.IDSALDLANGE
                       FROM LANCCONT,LANCCCUSTO
                       WHERE (LANCCCUSTO.CDEMPRESA  = P_CDEMPRESA)           AND
                             (LANCCCUSTO.NRLANCCONT = P_NRLANCCONT)          AND
                             (LANCCONT.CDEMPRESA    = LANCCCUSTO.CDEMPRESA)  AND
                             (LANCCONT.NRLANCCONT   = LANCCCUSTO.NRLANCCONT) AND
                             (LANCCONT.NRSEQLANC    = LANCCCUSTO.NRSEQLANC)) LOOP

      IF LANCCUSTO_C.IDSALDLANGE = 'S' THEN

         V_NRSEQCCEX := V_NRSEQCCEX + 1;

         INSERT INTO LANCCEXC
            (NRSEQCCEX, NRLANCONGE, CDEMPRESA,  CDCENTCUSEX, CDFILIALEX,
             CDCONTCCEX, DTLANCCCEX, VRLANCCCEX)
         VALUES
            (V_NRSEQCCEX, P_NRLANCCONT, P_CDEMPRESA, LANCCUSTO_C.CDCENTCUST, LANCCUSTO_C.CDFILIAL,
             LANCCUSTO_C.CDCONTCTBL, LANCCUSTO_C.DTLANCCONT, LANCCUSTO_C.VALOR);
      END IF;

   END LOOP;

   IF (P_EXEC_ALT = 'S' OR P_EXEC_ALT = 'E') THEN
      DELETE LANCCONT
      WHERE (LANCCONT.CDEMPRESA  = P_CDEMPRESA)  AND
            (LANCCONT.NRLANCCONT = P_NRLANCCONT);

   END IF;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXCLUI_LANCAMENTO','5.05.020'); END;
/

